>From c3801e7b9faf35eab4d98a75cd1d5feecad3deaf Mon Sep 17 00:00:00 2001
From: Ade Lee <alee@redhat.com>
Date: Tue, 14 May 2013 15:57:52 -0400
Subject: [PATCH] Add interfaces for managing profiles

This adds the initial framework for viewing and managing profiles.
Also adds CLI code for viewing/adding/deleting and editing profiles.
---
 .../src/com/netscape/cms/servlet/test/CATest.java  | 138 +++----
 .../certsrv/cert/CertEnrollmentRequest.java        |  69 ++--
 .../netscape/certsrv/profile/IPolicyDefault.java   |   1 +
 .../src/com/netscape/certsrv/profile/IProfile.java |  24 ++
 .../netscape/certsrv/profile/PolicyConstraint.java |  11 +
 .../certsrv/profile/PolicyConstraintValue.java     |  14 +-
 .../netscape/certsrv/profile/PolicyDefault.java    |  22 +
 .../netscape/certsrv/profile/ProfileClient.java    |  73 ++++
 .../com/netscape/certsrv/profile/ProfileData.java  | 289 ++++++++++++--
 .../com/netscape/certsrv/profile/ProfileInput.java | 113 ++++--
 .../netscape/certsrv/profile/ProfileOutput.java    |  52 ++-
 .../netscape/certsrv/profile/ProfileParameter.java |  66 +++
 .../netscape/certsrv/profile/ProfileResource.java  |  53 ++-
 .../com/netscape/certsrv/property/Descriptor.java  |   8 +
 .../netscape/cms/profile/common/BasicProfile.java  |  42 ++
 .../netscape/cms/servlet/cert/CertProcessor.java   |   7 +-
 .../servlet/cert/CertReviewResponseFactory.java    |   4 +-
 .../cms/servlet/cert/EnrollmentProcessor.java      |   7 +-
 .../servlet/profile/PolicyConstraintFactory.java   |   7 +-
 .../cms/servlet/profile/PolicyDefaultFactory.java  |  30 ++
 .../cms/servlet/profile/ProfileInputFactory.java   |  11 +-
 .../cms/servlet/profile/ProfileProcessServlet.java |   4 +-
 .../cms/servlet/profile/ProfileService.java        | 444 +++++++++++++++++++--
 .../src/com/netscape/cmstools/cli/MainCLI.java     |   2 +
 .../netscape/cmstools/profile/ProfileAddCLI.java   |  60 +++
 .../com/netscape/cmstools/profile/ProfileCLI.java  | 118 ++++++
 .../cmstools/profile/ProfileDisableCLI.java        |  34 ++
 .../cmstools/profile/ProfileEnableCLI.java         |  33 ++
 .../netscape/cmstools/profile/ProfileFindCLI.java  |  39 ++
 .../cmstools/profile/ProfileModifyCLI.java         |  61 +++
 .../cmstools/profile/ProfileRemoveCLI.java         |  33 ++
 .../netscape/cmstools/profile/ProfileShowCLI.java  |  71 ++++
 32 files changed, 1643 insertions(+), 297 deletions(-)
 create mode 100644 base/common/src/com/netscape/certsrv/profile/ProfileClient.java
 create mode 100644 base/common/src/com/netscape/certsrv/profile/ProfileParameter.java
 create mode 100644 base/java-tools/src/com/netscape/cmstools/profile/ProfileAddCLI.java
 create mode 100644 base/java-tools/src/com/netscape/cmstools/profile/ProfileCLI.java
 create mode 100644 base/java-tools/src/com/netscape/cmstools/profile/ProfileDisableCLI.java
 create mode 100644 base/java-tools/src/com/netscape/cmstools/profile/ProfileEnableCLI.java
 create mode 100644 base/java-tools/src/com/netscape/cmstools/profile/ProfileFindCLI.java
 create mode 100644 base/java-tools/src/com/netscape/cmstools/profile/ProfileModifyCLI.java
 create mode 100644 base/java-tools/src/com/netscape/cmstools/profile/ProfileRemoveCLI.java
 create mode 100644 base/java-tools/src/com/netscape/cmstools/profile/ProfileShowCLI.java

diff --git a/base/ca/functional/src/com/netscape/cms/servlet/test/CATest.java b/base/ca/functional/src/com/netscape/cms/servlet/test/CATest.java
index 33dcfdfee02bac37c86ef9b1b29debde64ea1bb0..3134f581466cef6e796b8d376dbcc6ad228e2cfd 100644
--- a/base/ca/functional/src/com/netscape/cms/servlet/test/CATest.java
+++ b/base/ca/functional/src/com/netscape/cms/servlet/test/CATest.java
@@ -18,8 +18,6 @@
 package com.netscape.cms.servlet.test;
 
 import java.util.Collection;
-import java.util.Iterator;
-import java.util.List;
 import java.util.Map;
 
 import org.apache.commons.cli.CommandLine;
@@ -45,6 +43,7 @@ import com.netscape.certsrv.cert.CertReviewResponse;
 import com.netscape.certsrv.cert.CertSearchRequest;
 import com.netscape.certsrv.client.ClientConfig;
 import com.netscape.certsrv.dbs.certdb.CertId;
+import com.netscape.certsrv.profile.ProfileAttribute;
 import com.netscape.certsrv.profile.ProfileData;
 import com.netscape.certsrv.profile.ProfileDataInfo;
 import com.netscape.certsrv.profile.ProfileDataInfos;
@@ -319,26 +318,26 @@ public class CATest {
         //Simulate a "caUserCert" Profile enrollment
 
         ProfileInput certReq = data.createInput("Key Generation");
-        certReq.setInputAttr("cert_request_type", "crmf");
-        certReq.setInputAttr(
+        certReq.addAttribute(new ProfileAttribute("cert_request_type", "crmf", null));
+        certReq.addAttribute(new ProfileAttribute(
                 "cert_request",
-                "MIIBozCCAZ8wggEFAgQBMQp8MIHHgAECpQ4wDDEKMAgGA1UEAxMBeKaBnzANBgkqhkiG9w0BAQEFAAOBjQAwgYkCgYEA2NgaPHp0jiohcP4M+ufrJOZEqH8GV+liu5JLbT8nWpkfhC+8EUBqT6g+n3qroSxIcNVGNdcsBEqs1utvpItzyslAbpdyat3WwQep1dWMzo6RHrPDuIoxNA0Yka1n3qEX4U//08cLQtUv2bYglYgN/hOCNQemLV6vZWAv0n7zelkCAwEAAakQMA4GA1UdDwEB/wQEAwIF4DAzMBUGCSsGAQUFBwUBAQwIcmVnVG9rZW4wGgYJKwYBBQUHBQECDA1hdXRoZW50aWNhdG9yoYGTMA0GCSqGSIb3DQEBBQUAA4GBAJ1VOQcaSEhdHa94s8kifVbSZ2WZeYE5//qxL6wVlEst20vq4ybj13CetnbN3+WT49Zkwp7Fg+6lALKgSk47suTg3EbbQDm+8yOrC0nc/q4PTRoHl0alMmUxIhirYc1t3xoCMqJewmjX1bNP8lpVIZAYFZo4eZCpZaiSkM5BeHhz");
+                "MIIBozCCAZ8wggEFAgQBMQp8MIHHgAECpQ4wDDEKMAgGA1UEAxMBeKaBnzANBgkqhkiG9w0BAQEFAAOBjQAwgYkCgYEA2NgaPHp0jiohcP4M+ufrJOZEqH8GV+liu5JLbT8nWpkfhC+8EUBqT6g+n3qroSxIcNVGNdcsBEqs1utvpItzyslAbpdyat3WwQep1dWMzo6RHrPDuIoxNA0Yka1n3qEX4U//08cLQtUv2bYglYgN/hOCNQemLV6vZWAv0n7zelkCAwEAAakQMA4GA1UdDwEB/wQEAwIF4DAzMBUGCSsGAQUFBwUBAQwIcmVnVG9rZW4wGgYJKwYBBQUHBQECDA1hdXRoZW50aWNhdG9yoYGTMA0GCSqGSIb3DQEBBQUAA4GBAJ1VOQcaSEhdHa94s8kifVbSZ2WZeYE5//qxL6wVlEst20vq4ybj13CetnbN3+WT49Zkwp7Fg+6lALKgSk47suTg3EbbQDm+8yOrC0nc/q4PTRoHl0alMmUxIhirYc1t3xoCMqJewmjX1bNP8lpVIZAYFZo4eZCpZaiSkM5BeHhz", null));
 
         ProfileInput subjectName = data.createInput("Subject Name");
-        subjectName.setInputAttr("sn_uid", "jmagne");
-        subjectName.setInputAttr("sn_e", "jmagne@redhat.com");
-        subjectName.setInputAttr("sn_c", "US");
-        subjectName.setInputAttr("sn_ou", "Development");
-        subjectName.setInputAttr("sn_ou1", "IPA");
-        subjectName.setInputAttr("sn_ou2", "Dogtag");
-        subjectName.setInputAttr("sn_ou3", "CA");
-        subjectName.setInputAttr("sn_cn", "Common");
-        subjectName.setInputAttr("sn_o", "RedHat");
+        subjectName.addAttribute(new ProfileAttribute("sn_uid", "jmagne", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_e", "jmagne@redhat.com", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_c", "US", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_ou", "Development", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_ou1", "IPA", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_ou2", "Dogtag", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_ou3", "CA", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_cn", "Common", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_o", "RedHat", null));
 
         ProfileInput submitter = data.createInput("Requestor Information");
-        submitter.setInputAttr("requestor_name", "admin");
-        submitter.setInputAttr("requestor_email", "admin@redhat.com");
-        submitter.setInputAttr("requestor_phone", "650-555-5555");
+        submitter.addAttribute(new ProfileAttribute("requestor_name", "admin", null));
+        submitter.addAttribute(new ProfileAttribute("requestor_email", "admin@redhat.com", null));
+        submitter.addAttribute(new ProfileAttribute("requestor_phone", "650-555-5555", null));
         return data;
     }
 
@@ -350,20 +349,20 @@ public class CATest {
         //Simulate a "caUserCert" Profile enrollment
 
         ProfileInput certReq = data.createInput("Key Generation");
-        certReq.setInputAttr("cert_request_type", "crmf");
-        certReq.setInputAttr(
+        certReq.addAttribute(new ProfileAttribute("cert_request_type", "crmf", null));
+        certReq.addAttribute(new ProfileAttribute(
                 "cert_request",
-                "MIIB5DCCAeAwggFGAgQTosnaMIIBB4ABAqVOMEwxETAPBgNVBAMTCGFsZWUgcmEzMR4wHAYJKoZIhvcNAQkBFg9hbGVlQHJlZGhhdC5jb20xFzAVBgoJkiaJk/IsZAEBEwdhbGVlcmEzpoGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCkQh3k+1323YgQD+oA9yzftqxbGQlsbz0f2OEeOL5h0uhg/qPlSNMjRN3mAeuaNyF0n/Bdxv4699gRTsyEaVJu7HX+kauSCZv+J0tvHiYuHQz1/TSscU9TNLyQjgXVKQFHEdjZa2cQNdmMDUFWrftAK6BFnsP3Tu712qZPAuBH9QIDAQABqRAwDgYDVR0PAQH/BAQDAgXgMDMwFQYJKwYBBQUHBQEBDAhyZWdUb2tlbjAaBgkrBgEFBQcFAQIMDWF1dGhlbnRpY2F0b3KhgZMwDQYJKoZIhvcNAQEFBQADgYEATNi3vMxn9KMto999sR4ik851jqbb6L0GL1KKgQ/hjIAACQb2H+0OpqeZ2+DcGd+oAQn1YZe8aPoFu+HOWjHlY1E2tm7TI1B6JpCL3TMag3mYryROX7l7LFEa1P730aGOWJF874bG8UWisU190zhCBQUqUjsd9DwaP42qM0gnzas=");
+                "MIIB5DCCAeAwggFGAgQTosnaMIIBB4ABAqVOMEwxETAPBgNVBAMTCGFsZWUgcmEzMR4wHAYJKoZIhvcNAQkBFg9hbGVlQHJlZGhhdC5jb20xFzAVBgoJkiaJk/IsZAEBEwdhbGVlcmEzpoGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQCkQh3k+1323YgQD+oA9yzftqxbGQlsbz0f2OEeOL5h0uhg/qPlSNMjRN3mAeuaNyF0n/Bdxv4699gRTsyEaVJu7HX+kauSCZv+J0tvHiYuHQz1/TSscU9TNLyQjgXVKQFHEdjZa2cQNdmMDUFWrftAK6BFnsP3Tu712qZPAuBH9QIDAQABqRAwDgYDVR0PAQH/BAQDAgXgMDMwFQYJKwYBBQUHBQEBDAhyZWdUb2tlbjAaBgkrBgEFBQcFAQIMDWF1dGhlbnRpY2F0b3KhgZMwDQYJKoZIhvcNAQEFBQADgYEATNi3vMxn9KMto999sR4ik851jqbb6L0GL1KKgQ/hjIAACQb2H+0OpqeZ2+DcGd+oAQn1YZe8aPoFu+HOWjHlY1E2tm7TI1B6JpCL3TMag3mYryROX7l7LFEa1P730aGOWJF874bG8UWisU190zhCBQUqUjsd9DwaP42qM0gnzas=", null));
 
         ProfileInput subjectName = data.createInput("Subject Name");
-        subjectName.setInputAttr("sn_uid", "aleera3");
-        subjectName.setInputAttr("sn_e", "alee@redhat.com");
-        subjectName.setInputAttr("sn_cn", "alee ra3");
+        subjectName.addAttribute(new ProfileAttribute("sn_uid", "aleera3", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_e", "alee@redhat.com", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_cn", "alee ra3", null));
 
         ProfileInput submitter = data.createInput("Requestor Information");
-        submitter.setInputAttr("requestor_name", "admin");
-        submitter.setInputAttr("requestor_email", "admin@redhat.com");
-        submitter.setInputAttr("requestor_phone", "650-555-1234");
+        submitter.addAttribute(new ProfileAttribute("requestor_name", "admin", null));
+        submitter.addAttribute(new ProfileAttribute("requestor_email", "admin@redhat.com", null));
+        submitter.addAttribute(new ProfileAttribute("requestor_phone", "650-555-1234", null));
         return data;
     }
 
@@ -375,19 +374,20 @@ public class CATest {
         //Simulate a "caUserCert" Profile enrollment
 
         ProfileInput certReq = data.createInput("Key Generation");
-        certReq.setInputAttr("cert_request_type", "pkcs10");
-        certReq.setInputAttr(
+        certReq.addAttribute(new ProfileAttribute("cert_request_type", "pkcs10", null));
+        certReq.addAttribute(new ProfileAttribute(
                 "cert_request",
-                "MIIBZjCB0AIBADAnMQ8wDQYDVQQKEwZyZWRoYXQxFDASBgNVBAMTC2FsZWUtd29ya3BjMIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDJtuKg9osJEBUwz8LoMQwwm1m7D97NNJEmvEhvBMet+VCtbd/erAFMoVXEgSKks/XFK2ViTeZYpp0A2pe4bm4yxowZm0b6von9BKGQ0jNtLemoOkGRWC/PP+fYP16aH62xu4z8MH1pBubdlAEp3Ppnr93aB1lzQaPVmcR3B4OWhwIDAQABoAAwDQYJKoZIhvcNAQEFBQADgYEAgZhZOe0LqQD5iywAO7sY0PANVGzzdcmoLZJjjASY3kU5E3K8u3FKh24WJxcWzdC+/FysDkJixJb7xGUm697QwZvGxmAIQH4yIebWJ2KLHQQgRJytjVYySrRo2Fuo/dm2zzf3+o8WBuD2eMsEjsZfuKxhz7EahvyC2y/CuTBA08s="
+                "MIIBZjCB0AIBADAnMQ8wDQYDVQQKEwZyZWRoYXQxFDASBgNVBAMTC2FsZWUtd29ya3BjMIGfMA0GCSqGSIb3DQEBAQUAA4GNADCBiQKBgQDJtuKg9osJEBUwz8LoMQwwm1m7D97NNJEmvEhvBMet+VCtbd/erAFMoVXEgSKks/XFK2ViTeZYpp0A2pe4bm4yxowZm0b6von9BKGQ0jNtLemoOkGRWC/PP+fYP16aH62xu4z8MH1pBubdlAEp3Ppnr93aB1lzQaPVmcR3B4OWhwIDAQABoAAwDQYJKoZIhvcNAQEFBQADgYEAgZhZOe0LqQD5iywAO7sY0PANVGzzdcmoLZJjjASY3kU5E3K8u3FKh24WJxcWzdC+/FysDkJixJb7xGUm697QwZvGxmAIQH4yIebWJ2KLHQQgRJytjVYySrRo2Fuo/dm2zzf3+o8WBuD2eMsEjsZfuKxhz7EahvyC2y/CuTBA08s=",
+                null)
         );
         ProfileInput subjectName = data.createInput("Subject Name");
-        subjectName.setInputAttr("sn_cn", "alee-workpc");
-        subjectName.setInputAttr("sn_o", "redhat");
+        subjectName.addAttribute(new ProfileAttribute("sn_cn", "alee-workpc", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_o", "redhat", null));
 
         ProfileInput submitter = data.createInput("Requestor Information");
-        submitter.setInputAttr("requestor_name", "admin");
-        submitter.setInputAttr("requestor_email", "admin@redhat.com");
-        submitter.setInputAttr("requestor_phone", "650-555-5555");
+        submitter.addAttribute(new ProfileAttribute("requestor_name", "admin", null));
+        submitter.addAttribute(new ProfileAttribute("requestor_email", "admin@redhat.com", null));
+        submitter.addAttribute(new ProfileAttribute("requestor_phone", "650-555-5555", null));
         return data;
     }
 
@@ -399,18 +399,9 @@ public class CATest {
         }
 
         Collection<ProfileDataInfo> listProfiles = pInfos.getProfileInfos();
-        Iterator<ProfileDataInfo> iter = null;
-
         if (listProfiles != null) {
-            iter = listProfiles.iterator();
-        }
-
-        log("\nProfiles found. \n");
-
-        while (iter != null && iter.hasNext()) {
-            ProfileDataInfo info = iter.next();
-
-            if (info != null) {
+            log("\nProfiles found. \n");
+            for (ProfileDataInfo info: listProfiles) {
                 printProfileDataInfo(info);
             }
         }
@@ -436,40 +427,19 @@ public class CATest {
         log("Name: " + info.getName());
         log("Description: " + info.getDescription());
         log("EnabledBy: " + info.getEnabledBy());
-        log("IsEnabled: " + info.getIsEnabled());
-        log("IsVisible: " + info.getIsVisible() + "\n\n");
+        log("Enabled: " + info.isEnabled());
+        log("Visible: " + info.isVisible() + "\n\n");
 
         log("Profile Input Information: \n");
 
-        List<ProfileInput> inputs = info.getProfileInputsList();
-
-        if (inputs != null) {
-            Iterator<ProfileInput> it = inputs.iterator();
-
-            ProfileInput curInput = null;
-            while (it.hasNext()) {
-                curInput = it.next();
-
-                if (curInput != null) {
-
-                    log("Input Name: " + curInput.getInputId());
-
-                    Map<String, String> attrs = curInput.getAttributes();
-
-                    if (!attrs.isEmpty()) {
-                        for (String key : attrs.keySet()) {
-                            String value = attrs.get(key);
-
-                            log("Input Attribute Name: " + key + "\n");
-                            log("Input Attribute Value: " + value + "\n");
-                        }
-                    }
-
-                }
+        Map<String, ProfileInput> inputs = info.getInputs();
+        for (Map.Entry<String, ProfileInput> entry : inputs.entrySet()) {
+            log("Input Id: " + entry.getKey());
+            for (ProfileAttribute attr: entry.getValue().getAttrs()) {
+                log("Input Attribute Name: " + attr.getName() + "\n");
+                log("Input Attribute Value: " + attr.getValue() + "\n");
             }
-
         }
-
     }
 
     private static void printCertInfos(CertDataInfos infos, String filter) {
@@ -480,18 +450,10 @@ public class CATest {
         }
 
         Collection<CertDataInfo> listCerts = infos.getCertInfos();
-        Iterator<CertDataInfo> iter = null;
-
         if (listCerts != null) {
-            iter = listCerts.iterator();
-        }
-
-        log("\nCertificates found with search filter: " + filter + "\n");
-
-        while (iter != null && iter.hasNext()) {
-            CertDataInfo info = iter.next();
-            if (info != null) {
-                printCertInfo(info);
+            log("\nCertificates found with search filter: " + filter + "\n");
+            for (CertDataInfo info: listCerts) {
+                if (info != null) printCertInfo(info);
             }
         }
     }
@@ -533,11 +495,7 @@ public class CATest {
             log("No requests found");
             return;
         }
-
-        Iterator<CertRequestInfo> iter = list.iterator();
-
-        while (iter != null && iter.hasNext()) {
-            CertRequestInfo info = iter.next();
+        for (CertRequestInfo info: list) {
             printRequestInfo(info);
         }
     }
diff --git a/base/common/src/com/netscape/certsrv/cert/CertEnrollmentRequest.java b/base/common/src/com/netscape/certsrv/cert/CertEnrollmentRequest.java
index fefef9a4625433851f408781683f8d2c4be00d23..f5feda0fda0ade4d0675a7dec7d233f977eb9815 100644
--- a/base/common/src/com/netscape/certsrv/cert/CertEnrollmentRequest.java
+++ b/base/common/src/com/netscape/certsrv/cert/CertEnrollmentRequest.java
@@ -25,9 +25,7 @@ import java.io.ByteArrayInputStream;
 import java.io.ByteArrayOutputStream;
 import java.util.ArrayList;
 import java.util.HashMap;
-import java.util.Iterator;
 import java.util.List;
-import java.util.Map;
 
 import javax.ws.rs.core.MultivaluedMap;
 import javax.xml.bind.JAXBContext;
@@ -39,6 +37,7 @@ import javax.xml.bind.annotation.XmlAccessorType;
 import javax.xml.bind.annotation.XmlElement;
 import javax.xml.bind.annotation.XmlRootElement;
 
+import com.netscape.certsrv.profile.ProfileAttribute;
 import com.netscape.certsrv.profile.ProfileInput;
 import com.netscape.certsrv.profile.ProfileOutput;
 
@@ -111,7 +110,7 @@ public class CertEnrollmentRequest {
     }
 
     public void addInput(ProfileInput input) {
-        ProfileInput curInput = getInput(input.getInputId());
+        ProfileInput curInput = getInput(input.getName());
         if (curInput != null) {
             getInputs().remove(curInput);
         }
@@ -119,7 +118,7 @@ public class CertEnrollmentRequest {
     }
 
     public void deleteInput(ProfileInput input) {
-        ProfileInput curInput = getInput(input.getInputId());
+        ProfileInput curInput = getInput(input.getName());
         if (curInput != null) {
             getInputs().remove(curInput);
         }
@@ -133,7 +132,7 @@ public class CertEnrollmentRequest {
             return oldInput;
 
         ProfileInput newInput = new ProfileInput();
-        newInput.setInputId(name);
+        newInput.setName(name);
 
         getInputs().add(newInput);
 
@@ -141,23 +140,16 @@ public class CertEnrollmentRequest {
     }
 
     public ProfileInput getInput(String name) {
-
         ProfileInput input = null;
-
-        Iterator<ProfileInput> it = getInputs().iterator();
-
-        ProfileInput curInput = null;
-        while (it.hasNext()) {
-            curInput = it.next();
-            if (curInput != null && curInput.getInputId().equals(name))
+        for (ProfileInput curInput: getInputs()) {
+            if (curInput != null && curInput.getName().equals(name))
                 break;
         }
-
         return input;
     }
 
     public void addOutput(ProfileOutput output) {
-        ProfileOutput curOutput = getOutput(output.getOutputId());
+        ProfileOutput curOutput = getOutput(output.getName());
         if (curOutput != null) {
             getOutputs().remove(curOutput);
         }
@@ -165,7 +157,7 @@ public class CertEnrollmentRequest {
     }
 
     public void deleteOutput(ProfileOutput output) {
-        ProfileOutput curOutput = getOutput(output.getOutputId());
+        ProfileOutput curOutput = getOutput(output.getName());
         if (curOutput != null) {
             getInputs().remove(curOutput);
         }
@@ -173,15 +165,10 @@ public class CertEnrollmentRequest {
 
     public ProfileOutput getOutput(String name) {
         ProfileOutput output = null;
-        ProfileOutput curOutput = null;
-
-        Iterator<ProfileOutput> it = getOutputs().iterator();
-        while (it.hasNext()) {
-            curOutput = it.next();
-            if (curOutput != null && curOutput.getOutputId().equals(name))
+        for (ProfileOutput curOutput: getOutputs()) {
+            if (curOutput != null && curOutput.getName().equals(name))
                 break;
         }
-
         return output;
     }
 
@@ -201,9 +188,8 @@ public class CertEnrollmentRequest {
         if (remoteAddr != null) ret.put("remoteAddr", remoteAddr);
 
         for (ProfileInput input: inputs) {
-            Map<String, String> attrs = input.getAttributes();
-            for (Map.Entry<String, String> entry: attrs.entrySet()) {
-                ret.put(entry.getKey(), entry.getValue());
+            for (ProfileAttribute attr:input.getAttrs()) {
+                ret.put(attr.getName(), attr.getValue());
             }
         }
 
@@ -218,26 +204,27 @@ public class CertEnrollmentRequest {
         //Simulate a "caUserCert" Profile enrollment
 
         ProfileInput certReq = data.createInput("KeyGenInput");
-        certReq.setInputAttr("cert_request_type", "crmf");
-        certReq.setInputAttr(
+        certReq.addAttribute(new ProfileAttribute("cert_request_type", "crmf", null));
+        certReq.addAttribute(new ProfileAttribute(
                 "cert_request",
-                "MIIBozCCAZ8wggEFAgQBMQp8MIHHgAECpQ4wDDEKMAgGA1UEAxMBeKaBnzANBgkqhkiG9w0BAQEFAAOBjQAwgYkCgYEA2NgaPHp0jiohcP4M+ufrJOZEqH8GV+liu5JLbT8nWpkfhC+8EUBqT6g+n3qroSxIcNVGNdcsBEqs1utvpItzyslAbpdyat3WwQep1dWMzo6RHrPDuIoxNA0Yka1n3qEX4U//08cLQtUv2bYglYgN/hOCNQemLV6vZWAv0n7zelkCAwEAAakQMA4GA1UdDwEB/wQEAwIF4DAzMBUGCSsGAQUFBwUBAQwIcmVnVG9rZW4wGgYJKwYBBQUHBQECDA1hdXRoZW50aWNhdG9yoYGTMA0GCSqGSIb3DQEBBQUAA4GBAJ1VOQcaSEhdHa94s8kifVbSZ2WZeYE5//qxL6wVlEst20vq4ybj13CetnbN3+WT49Zkwp7Fg+6lALKgSk47suTg3EbbQDm+8yOrC0nc/q4PTRoHl0alMmUxIhirYc1t3xoCMqJewmjX1bNP8lpVIZAYFZo4eZCpZaiSkM5BeHhz");
+                "MIIBozCCAZ8wggEFAgQBMQp8MIHHgAECpQ4wDDEKMAgGA1UEAxMBeKaBnzANBgkqhkiG9w0BAQEFAAOBjQAwgYkCgYEA2NgaPHp0jiohcP4M+ufrJOZEqH8GV+liu5JLbT8nWpkfhC+8EUBqT6g+n3qroSxIcNVGNdcsBEqs1utvpItzyslAbpdyat3WwQep1dWMzo6RHrPDuIoxNA0Yka1n3qEX4U//08cLQtUv2bYglYgN/hOCNQemLV6vZWAv0n7zelkCAwEAAakQMA4GA1UdDwEB/wQEAwIF4DAzMBUGCSsGAQUFBwUBAQwIcmVnVG9rZW4wGgYJKwYBBQUHBQECDA1hdXRoZW50aWNhdG9yoYGTMA0GCSqGSIb3DQEBBQUAA4GBAJ1VOQcaSEhdHa94s8kifVbSZ2WZeYE5//qxL6wVlEst20vq4ybj13CetnbN3+WT49Zkwp7Fg+6lALKgSk47suTg3EbbQDm+8yOrC0nc/q4PTRoHl0alMmUxIhirYc1t3xoCMqJewmjX1bNP8lpVIZAYFZo4eZCpZaiSkM5BeHhz",
+                null));
 
         ProfileInput subjectName = data.createInput("SubjectNameInput");
-        subjectName.setInputAttr("sn_uid", "jmagne");
-        subjectName.setInputAttr("sn_e", "jmagne@redhat.com");
-        subjectName.setInputAttr("sn_c", "US");
-        subjectName.setInputAttr("sn_ou", "Development");
-        subjectName.setInputAttr("sn_ou1", "IPA");
-        subjectName.setInputAttr("sn_ou2", "Dogtag");
-        subjectName.setInputAttr("sn_ou3", "CA");
-        subjectName.setInputAttr("sn_cn", "Common");
-        subjectName.setInputAttr("sn_o", "RedHat");
+        subjectName.addAttribute(new ProfileAttribute("sn_uid", "jmagne", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_e", "jmagne@redhat.com", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_c", "US", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_ou", "Development", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_ou1", "IPA", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_ou2", "Dogtag", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_ou3", "CA", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_cn", "Common", null));
+        subjectName.addAttribute(new ProfileAttribute("sn_o", "RedHat", null));
 
         ProfileInput submitter = data.createInput("SubmitterInfoInput");
-        submitter.setInputAttr("requestor_name", "admin");
-        submitter.setInputAttr("requestor_email", "admin@redhat.com");
-        submitter.setInputAttr("requestor_phone", "650-555-5555");
+        submitter.addAttribute(new ProfileAttribute("requestor_name", "admin", null));
+        submitter.addAttribute(new ProfileAttribute("requestor_email", "admin@redhat.com", null));
+        submitter.addAttribute(new ProfileAttribute("requestor_phone", "650-555-5555", null));
 
         try {
             JAXBContext context = JAXBContext.newInstance(CertEnrollmentRequest.class);
diff --git a/base/common/src/com/netscape/certsrv/profile/IProfile.java b/base/common/src/com/netscape/certsrv/profile/IProfile.java
index 9125b2f69f31aacc44d98230a468072432594026..1a2b7aa68b05fcc668229d13801d897ba8a3637f 100644
--- a/base/common/src/com/netscape/certsrv/profile/IProfile.java
+++ b/base/common/src/com/netscape/certsrv/profile/IProfile.java
@@ -120,6 +120,8 @@ public interface IProfile {
      */
     public void setAuthenticatorId(String id);
 
+    public void setAuthzAcl(String id);
+
     /**
      * Retrieves the associated authenticator instance.
      *
@@ -266,6 +268,12 @@ public interface IProfile {
     public void deleteProfileInput(String inputId) throws EProfileException;
 
     /**
+     * Delete all profile inputs
+     * @throws EProfileException
+     */
+    public void deleteAllProfileInputs() throws EProfileException;
+
+    /**
      * Deletes output policy by id.
      *
      * @param outputId id of the output policy
@@ -274,6 +282,12 @@ public interface IProfile {
     public void deleteProfileOutput(String outputId) throws EProfileException;
 
     /**
+     * Delete all profile inputs
+     * @exception EProfileException
+     */
+    public void deleteAllProfileOutputs() throws EProfileException;
+
+    /**
      * Creates a input policy.
      *
      * @param id input policy id
@@ -309,6 +323,12 @@ public interface IProfile {
             throws EProfileException;
 
     /**
+     * Delete all profile policies
+     * @exception EProfileException
+     */
+    public void deleteAllProfilePolicies() throws EProfileException;
+
+    /**
      * Retrieves a policy.
      *
      * @param setId set id
@@ -405,4 +425,8 @@ public interface IProfile {
      */
     public void submit(IAuthToken token, IRequest request)
             throws EDeferException, EProfileException;
+
+    public void setRenewal(boolean renewal);
+
+    public void setXMLOutput(boolean xmlOutput);
 }
diff --git a/base/common/src/com/netscape/certsrv/profile/PolicyConstraint.java b/base/common/src/com/netscape/certsrv/profile/PolicyConstraint.java
index 8b43661a2c4ba2a4bd1774d0aac9d1852a0dab63..a0f4e9defcb71eb24b930ce275dbc4bd1f41bd4f 100644
--- a/base/common/src/com/netscape/certsrv/profile/PolicyConstraint.java
+++ b/base/common/src/com/netscape/certsrv/profile/PolicyConstraint.java
@@ -35,6 +35,9 @@ public class PolicyConstraint {
     @XmlElement(name="description")
     private String text;
 
+    @XmlElement
+    private String classId;
+
     @XmlElement(name = "constraint")
     private List<PolicyConstraintValue> constraints = new ArrayList<PolicyConstraintValue>();
 
@@ -62,6 +65,14 @@ public class PolicyConstraint {
         this.text = text;
     }
 
+    public String getClassId() {
+        return classId;
+    }
+
+    public void setClassId(String classId) {
+        this.classId = classId;
+    }
+
     public List<PolicyConstraintValue> getConstraints() {
         return constraints;
     }
diff --git a/base/common/src/com/netscape/certsrv/profile/PolicyConstraintValue.java b/base/common/src/com/netscape/certsrv/profile/PolicyConstraintValue.java
index 5241ad8323c55f755357065f4b9baa040f59ff45..a16b4c59d67741ebb23d8c451a368172f087f74b 100644
--- a/base/common/src/com/netscape/certsrv/profile/PolicyConstraintValue.java
+++ b/base/common/src/com/netscape/certsrv/profile/PolicyConstraintValue.java
@@ -34,13 +34,17 @@ public class PolicyConstraintValue {
     @XmlElement
     private Descriptor descriptor;
 
+    @XmlElement
+    private String value;
+
     public PolicyConstraintValue() {
         // required for jax-b
     }
 
-    public PolicyConstraintValue(String name, Descriptor descriptor) {
+    public PolicyConstraintValue(String name, Descriptor descriptor, String value) {
         this.name = name;
         this.descriptor = descriptor;
+        this.value = value;
     }
 
     public String getName() {
@@ -58,4 +62,12 @@ public class PolicyConstraintValue {
     public void setDescriptor(Descriptor descriptor) {
         this.descriptor = descriptor;
     }
+
+    public String getValue() {
+        return value;
+    }
+
+    public void setValue(String value) {
+        this.value = value;
+    }
 }
diff --git a/base/common/src/com/netscape/certsrv/profile/PolicyDefault.java b/base/common/src/com/netscape/certsrv/profile/PolicyDefault.java
index 2b95cf5f00af87451ed302b0bd4a7ef5c226b24b..f92242cc18c068dae841e1a86b10793216187167 100644
--- a/base/common/src/com/netscape/certsrv/profile/PolicyDefault.java
+++ b/base/common/src/com/netscape/certsrv/profile/PolicyDefault.java
@@ -32,12 +32,18 @@ public class PolicyDefault {
     @XmlAttribute(name="id")
     private String name;
 
+    @XmlAttribute
+    private String classId;
+
     @XmlElement(name="description")
     private String text;
 
     @XmlElement(name="policyAttribute")
     private List<ProfileAttribute> attributes = new ArrayList<ProfileAttribute>();
 
+    @XmlElement(name = "params")
+    private List<ProfileParameter> params = new ArrayList<ProfileParameter>();
+
     public PolicyDefault() {
         // required for jaxb
     }
@@ -62,6 +68,14 @@ public class PolicyDefault {
         this.text = text;
     }
 
+    public String getClassId() {
+        return classId;
+    }
+
+    public void setClassId(String classId) {
+        this.classId = classId;
+    }
+
     public List<ProfileAttribute> getAttributes() {
         return attributes;
     }
@@ -70,4 +84,12 @@ public class PolicyDefault {
         this.attributes = attributes;
     }
 
+    public List<ProfileParameter> getParams() {
+        return params;
+    }
+
+    public void setParams(List<ProfileParameter> params) {
+        this.params = params;
+    }
+
 }
